unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  LMDCustomComponent, LMDWndProcComponent, LMDTrayIcon, CPort, StdCtrls,
  ExtCtrls;

type
  TForm1 = class(TForm)
    cp: TComPort;
    ti: TLMDTrayIcon;
    Timer1: TTimer;
    procedure cpRxChar;
    procedure tiDblClick(Sender: TObject);
    procedure tiClick(Sender: TObject);
    procedure cpAfterOpen(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure sendkey(Key : byte);
begin
  keybd_event(Key, 0, KEYEVENTF_EXTENDEDKEY, 0);
end;

procedure releasekey(Key : byte);
begin
  keybd_event(Key, 0, KEYEVENTF_EXTENDEDKEY OR KEYEVENTF_KEYUP, 0);
end;

Procedure PostKeyEx32( key: Word; Const shift: TShiftState; specialkey, k_up: Boolean);
var flag:DWORD;
begin
    If specialkey Then
      flag := KEYEVENTF_EXTENDEDKEY
    Else
      flag := 0;
    if k_up then flag := flag or KEYEVENTF_KEYUP;
    keybd_event( key, MapvirtualKey( key, 0 ), flag, 0 );
end;

procedure TForm1.cpRxChar;
begin
  if csRing in cp.Signals then // Wenn Ring (Pin 9) gegen +12V geschaltet wird, reagiert es hier
   PostKeyEx32(VK_LEFT,[],true,false);
  if csDSR in cp.Signals then  // Wenn DSR (Pin 6) gegen +12V geschaltet wird, reagiert es hier
   PostKeyEx32(VK_RIGHT,[],true,false);
  PostKeyEx32(VK_LEFT,[],true,true);PostKeyEx32(VK_RIGHT,[],true,true);
end;

procedure TForm1.tiDblClick(Sender: TObject);
begin
  close;
end;

procedure TForm1.tiClick(Sender: TObject);
begin
  show;
end;

procedure TForm1.cpAfterOpen(Sender: TObject);
begin
  cp.SetDTR(true); // Pin 4 auf +12V
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  cpRxChar;
end;

end.
